diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ctrl-headers.cc ns-3.38/src/wifi/model/ctrl-headers.cc
--- ns-3.37/src/wifi/model/ctrl-headers.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/ctrl-headers.cc	2023-03-16 20:54:23.852869300 -0700
@@ -366,7 +366,7 @@
             i.WriteHtolsbU16(m_baInfo[index].m_aidTidInfo);
             if (GetAid11(index) != 2045)
             {
-                if (m_baInfo[index].m_bitmap.size() > 0)
+                if (!m_baInfo[index].m_bitmap.empty())
                 {
                     i.WriteHtolsbU16(GetStartingSequenceControl(index));
                     i = SerializeBitmap(i, index);
@@ -730,7 +730,7 @@
     else if (m_baType.m_variant == BlockAckType::MULTI_STA)
     {
         NS_ASSERT(m_baInfo.size() == m_baType.m_bitmapLen.size());
-        NS_ASSERT_MSG(m_baInfo[index].m_bitmap.size() > 0,
+        NS_ASSERT_MSG(!m_baInfo[index].m_bitmap.empty(),
                       "This Per AID TID Info subfield has no Starting Sequence Control subfield");
 
         if (m_baType.m_bitmapLen[index] == 16)
@@ -1068,12 +1068,15 @@
  * Trigger frame - User Info field
  ***********************************/
 
-CtrlTriggerUserInfoField::CtrlTriggerUserInfoField(uint8_t triggerType)
-    : m_aid12(0),
+CtrlTriggerUserInfoField::CtrlTriggerUserInfoField(TriggerFrameType triggerType,
+                                                   TriggerFrameVariant variant)
+    : m_variant(variant),
+      m_aid12(0),
       m_ruAllocation(0),
       m_ulFecCodingType(false),
       m_ulMcs(0),
       m_ulDcm(false),
+      m_ps160(true),
       m_ulTargetRssi(0),
       m_triggerType(triggerType),
       m_basicTriggerDependentUserInfo(0)
@@ -1096,11 +1099,13 @@
         return *this;
     }
 
+    m_variant = userInfo.m_variant;
     m_aid12 = userInfo.m_aid12;
     m_ruAllocation = userInfo.m_ruAllocation;
     m_ulFecCodingType = userInfo.m_ulFecCodingType;
     m_ulMcs = userInfo.m_ulMcs;
     m_ulDcm = userInfo.m_ulDcm;
+    m_ps160 = userInfo.m_ps160;
     m_bits26To31 = userInfo.m_bits26To31;
     m_ulTargetRssi = userInfo.m_ulTargetRssi;
     m_basicTriggerDependentUserInfo = userInfo.m_basicTriggerDependentUserInfo;
@@ -1111,7 +1116,8 @@
 void
 CtrlTriggerUserInfoField::Print(std::ostream& os) const
 {
-    os << ", USER_INFO AID=" << m_aid12 << ", RU_Allocation=" << +m_ruAllocation
+    os << ", USER_INFO " << (m_variant == TriggerFrameVariant::HE ? "HE" : "EHT")
+       << " variant AID=" << m_aid12 << ", RU_Allocation=" << +m_ruAllocation
        << ", MCS=" << +m_ulMcs;
 }
 
@@ -1123,14 +1129,15 @@
 
     switch (m_triggerType)
     {
-    case BASIC_TRIGGER:
-    case BFRP_TRIGGER:
+    case TriggerFrameType::BASIC_TRIGGER:
+    case TriggerFrameType::BFRP_TRIGGER:
         size += 1;
         break;
-    case MU_BAR_TRIGGER:
+    case TriggerFrameType::MU_BAR_TRIGGER:
         size +=
             m_muBarTriggerDependentUserInfo.GetSerializedSize(); // BAR Control and BAR Information
         break;
+    default:;
         // The Trigger Dependent User Info subfield is not present in the other variants
     }
 
@@ -1140,10 +1147,12 @@
 Buffer::Iterator
 CtrlTriggerUserInfoField::Serialize(Buffer::Iterator start) const
 {
-    NS_ABORT_MSG_IF(m_triggerType == BFRP_TRIGGER, "BFRP Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == GCR_MU_BAR_TRIGGER,
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
+                    "BFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER,
                     "GCR-MU-BAR Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == NFRP_TRIGGER, "NFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
+                    "NFRP Trigger frame is not supported");
 
     Buffer::Iterator i = start;
 
@@ -1152,7 +1161,10 @@
     userInfo |= (m_ruAllocation << 12);
     userInfo |= (m_ulFecCodingType ? 1 << 20 : 0);
     userInfo |= (m_ulMcs & 0x0f) << 21;
-    userInfo |= (m_ulDcm ? 1 << 25 : 0);
+    if (m_variant == TriggerFrameVariant::HE)
+    {
+        userInfo |= (m_ulDcm ? 1 << 25 : 0);
+    }
 
     if (m_aid12 != 0 && m_aid12 != 2045)
     {
@@ -1166,16 +1178,21 @@
     }
 
     i.WriteHtolsbU32(userInfo);
-    // Here we need to write 8 bits covering the UL Target RSSI (7 bits) and the
-    // Reserved bit. Given how m_ulTargetRssi is set, writing m_ulTargetRssi
-    // leads to setting the Reserved bit to zero
-    i.WriteU8(m_ulTargetRssi);
+    // Here we need to write 8 bits covering the UL Target RSSI (7 bits) and B39, which is
+    // reserved in the HE variant and the PS160 subfield in the EHT variant.
+    uint8_t bit32To39 = m_ulTargetRssi;
+    if (m_variant == TriggerFrameVariant::EHT)
+    {
+        bit32To39 |= (m_ps160 ? 1 << 7 : 0);
+    }
 
-    if (m_triggerType == BASIC_TRIGGER)
+    i.WriteU8(bit32To39);
+
+    if (m_triggerType == TriggerFrameType::BASIC_TRIGGER)
     {
         i.WriteU8(m_basicTriggerDependentUserInfo);
     }
-    else if (m_triggerType == MU_BAR_TRIGGER)
+    else if (m_triggerType == TriggerFrameType::MU_BAR_TRIGGER)
     {
         m_muBarTriggerDependentUserInfo.Serialize(i);
         i.Next(m_muBarTriggerDependentUserInfo.GetSerializedSize());
@@ -1187,10 +1204,12 @@
 Buffer::Iterator
 CtrlTriggerUserInfoField::Deserialize(Buffer::Iterator start)
 {
-    NS_ABORT_MSG_IF(m_triggerType == BFRP_TRIGGER, "BFRP Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == GCR_MU_BAR_TRIGGER,
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
+                    "BFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER,
                     "GCR-MU-BAR Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == NFRP_TRIGGER, "NFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
+                    "NFRP Trigger frame is not supported");
 
     Buffer::Iterator i = start;
 
@@ -1201,7 +1220,10 @@
     m_ruAllocation = (userInfo >> 12) & 0xff;
     m_ulFecCodingType = (userInfo >> 20) & 0x01;
     m_ulMcs = (userInfo >> 21) & 0x0f;
-    m_ulDcm = (userInfo >> 25) & 0x01;
+    if (m_variant == TriggerFrameVariant::HE)
+    {
+        m_ulDcm = (userInfo >> 25) & 0x01;
+    }
 
     if (m_aid12 != 0 && m_aid12 != 2045)
     {
@@ -1214,13 +1236,18 @@
         m_bits26To31.raRuInformation.moreRaRu = (userInfo >> 31) & 0x01;
     }
 
-    m_ulTargetRssi = i.ReadU8() & 0x7f; // B39 is reserved
+    uint8_t bit32To39 = i.ReadU8();
+    m_ulTargetRssi = bit32To39 & 0x7f; // B39 is reserved in HE variant
+    if (m_variant == TriggerFrameVariant::EHT)
+    {
+        m_ps160 = (bit32To39 >> 7) == 1;
+    }
 
-    if (m_triggerType == BASIC_TRIGGER)
+    if (m_triggerType == TriggerFrameType::BASIC_TRIGGER)
     {
         m_basicTriggerDependentUserInfo = i.ReadU8();
     }
-    else if (m_triggerType == MU_BAR_TRIGGER)
+    else if (m_triggerType == TriggerFrameType::MU_BAR_TRIGGER)
     {
         uint32_t len = m_muBarTriggerDependentUserInfo.Deserialize(i);
         i.Next(len);
@@ -1232,7 +1259,22 @@
 TriggerFrameType
 CtrlTriggerUserInfoField::GetType() const
 {
-    return static_cast<TriggerFrameType>(m_triggerType);
+    return m_triggerType;
+}
+
+WifiPreamble
+CtrlTriggerUserInfoField::GetPreambleType() const
+{
+    switch (m_variant)
+    {
+    case TriggerFrameVariant::HE:
+        return WIFI_PREAMBLE_HE_TB;
+    case TriggerFrameVariant::EHT:
+        return WIFI_PREAMBLE_EHT_TB;
+    default:
+        NS_ABORT_MSG("Unexpected variant: " << +static_cast<uint8_t>(m_variant));
+    }
+    return WIFI_PREAMBLE_LONG; // to silence warning
 }
 
 void
@@ -1263,6 +1305,8 @@
 CtrlTriggerUserInfoField::SetRuAllocation(HeRu::RuSpec ru)
 {
     NS_ABORT_MSG_IF(ru.GetIndex() == 0, "Valid indices start at 1");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
+                    "SetMuRtsRuAllocation() must be used for MU-RTS");
 
     switch (ru.GetRuType())
     {
@@ -1304,6 +1348,9 @@
 HeRu::RuSpec
 CtrlTriggerUserInfoField::GetRuAllocation() const
 {
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
+                    "GetMuRtsRuAllocation() must be used for MU-RTS");
+
     HeRu::RuType ruType;
     std::size_t index;
 
@@ -1355,6 +1402,39 @@
 }
 
 void
+CtrlTriggerUserInfoField::SetMuRtsRuAllocation(uint8_t value)
+{
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_RTS_TRIGGER,
+                    "SetMuRtsRuAllocation() can only be used for MU-RTS");
+    NS_ABORT_MSG_IF(
+        value < 61 || value > 68,
+        "Value "
+            << +value
+            << " is not admitted for B7-B1 of the RU Allocation subfield of MU-RTS Trigger Frames");
+
+    m_ruAllocation = (value << 1);
+    if (value == 68)
+    {
+        // set B0 for 160 MHz and 80+80 MHz indication
+        m_ruAllocation++;
+    }
+}
+
+uint8_t
+CtrlTriggerUserInfoField::GetMuRtsRuAllocation() const
+{
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_RTS_TRIGGER,
+                    "GetMuRtsRuAllocation() can only be used for MU-RTS");
+    uint8_t value = (m_ruAllocation >> 1);
+    NS_ABORT_MSG_IF(
+        value < 61 || value > 68,
+        "Value "
+            << +value
+            << " is not admitted for B7-B1 of the RU Allocation subfield of MU-RTS Trigger Frames");
+    return value;
+}
+
+void
 CtrlTriggerUserInfoField::SetUlFecCodingType(bool ldpc)
 {
     m_ulFecCodingType = ldpc;
@@ -1382,12 +1462,14 @@
 void
 CtrlTriggerUserInfoField::SetUlDcm(bool dcm)
 {
+    NS_ASSERT_MSG(m_variant == TriggerFrameVariant::HE, "UL DCM flag only present in HE variant");
     m_ulDcm = dcm;
 }
 
 bool
 CtrlTriggerUserInfoField::GetUlDcm() const
 {
+    NS_ASSERT_MSG(m_variant == TriggerFrameVariant::HE, "UL DCM flag only present in HE variant");
     return m_ulDcm;
 }
 
@@ -1481,7 +1563,7 @@
                                                      uint8_t tidLimit,
                                                      AcIndex prefAc)
 {
-    NS_ABORT_MSG_IF(m_triggerType != BASIC_TRIGGER, "Not a Basic Trigger Frame");
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::BASIC_TRIGGER, "Not a Basic Trigger Frame");
 
     m_basicTriggerDependentUserInfo = (spacingFactor & 0x03) |
                                       (tidLimit & 0x07) << 2
@@ -1492,7 +1574,7 @@
 uint8_t
 CtrlTriggerUserInfoField::GetMpduMuSpacingFactor() const
 {
-    NS_ABORT_MSG_IF(m_triggerType != BASIC_TRIGGER, "Not a Basic Trigger Frame");
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::BASIC_TRIGGER, "Not a Basic Trigger Frame");
 
     return m_basicTriggerDependentUserInfo & 0x03;
 }
@@ -1500,7 +1582,7 @@
 uint8_t
 CtrlTriggerUserInfoField::GetTidAggregationLimit() const
 {
-    NS_ABORT_MSG_IF(m_triggerType != BASIC_TRIGGER, "Not a Basic Trigger Frame");
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::BASIC_TRIGGER, "Not a Basic Trigger Frame");
 
     return (m_basicTriggerDependentUserInfo & 0x1c) >> 2;
 }
@@ -1508,7 +1590,7 @@
 AcIndex
 CtrlTriggerUserInfoField::GetPreferredAc() const
 {
-    NS_ABORT_MSG_IF(m_triggerType != BASIC_TRIGGER, "Not a Basic Trigger Frame");
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::BASIC_TRIGGER, "Not a Basic Trigger Frame");
 
     return AcIndex((m_basicTriggerDependentUserInfo & 0xc0) >> 6);
 }
@@ -1516,7 +1598,8 @@
 void
 CtrlTriggerUserInfoField::SetMuBarTriggerDepUserInfo(const CtrlBAckRequestHeader& bar)
 {
-    NS_ABORT_MSG_IF(m_triggerType != MU_BAR_TRIGGER, "Not a MU-BAR Trigger frame");
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_BAR_TRIGGER,
+                    "Not a MU-BAR Trigger frame");
     NS_ABORT_MSG_IF(bar.GetType().m_variant != BlockAckReqType::COMPRESSED &&
                         bar.GetType().m_variant != BlockAckReqType::MULTI_TID,
                     "BAR Control indicates it is neither the Compressed nor the Multi-TID variant");
@@ -1526,7 +1609,8 @@
 const CtrlBAckRequestHeader&
 CtrlTriggerUserInfoField::GetMuBarTriggerDepUserInfo() const
 {
-    NS_ABORT_MSG_IF(m_triggerType != MU_BAR_TRIGGER, "Not a MU-BAR Trigger frame");
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_BAR_TRIGGER,
+                    "Not a MU-BAR Trigger frame");
 
     return m_muBarTriggerDependentUserInfo;
 }
@@ -1538,7 +1622,8 @@
 NS_OBJECT_ENSURE_REGISTERED(CtrlTriggerHeader);
 
 CtrlTriggerHeader::CtrlTriggerHeader()
-    : m_triggerType(0),
+    : m_variant(TriggerFrameVariant::HE),
+      m_triggerType(TriggerFrameType::BASIC_TRIGGER),
       m_ulLength(0),
       m_moreTF(false),
       m_csRequired(false),
@@ -1552,6 +1637,22 @@
 CtrlTriggerHeader::CtrlTriggerHeader(TriggerFrameType type, const WifiTxVector& txVector)
     : CtrlTriggerHeader()
 {
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
+                    "This constructor cannot be used for MU-RTS");
+
+    switch (txVector.GetPreambleType())
+    {
+    case WIFI_PREAMBLE_HE_TB:
+        m_variant = TriggerFrameVariant::HE;
+        break;
+    case WIFI_PREAMBLE_EHT_TB:
+        m_variant = TriggerFrameVariant::EHT;
+        break;
+    default:
+        NS_ABORT_MSG("Cannot create a TF out of a TXVECTOR with preamble type: "
+                     << txVector.GetPreambleType());
+    }
+
     m_triggerType = type;
     SetUlBandwidth(txVector.GetChannelWidth());
     SetUlLength(txVector.GetLength());
@@ -1569,7 +1670,7 @@
         CtrlTriggerUserInfoField& ui = AddUserInfoField();
         ui.SetAid12(userInfo.first);
         ui.SetRuAllocation(userInfo.second.ru);
-        ui.SetUlMcs(userInfo.second.mcs.GetMcsValue());
+        ui.SetUlMcs(userInfo.second.mcs);
         ui.SetSsAllocation(1, userInfo.second.nss); // MU-MIMO is not supported
     }
 }
@@ -1587,6 +1688,7 @@
         return *this;
     }
 
+    m_variant = trigger.m_variant;
     m_triggerType = trigger.m_triggerType;
     m_ulLength = trigger.m_ulLength;
     m_moreTF = trigger.m_moreTF;
@@ -1628,6 +1730,20 @@
     }
 }
 
+void
+CtrlTriggerHeader::SetVariant(TriggerFrameVariant variant)
+{
+    NS_ABORT_MSG_IF(!m_userInfoFields.empty(),
+                    "Cannot change Common Info field variant if User Info fields are present");
+    m_variant = variant;
+}
+
+TriggerFrameVariant
+CtrlTriggerHeader::GetVariant() const
+{
+    return m_variant;
+}
+
 uint32_t
 CtrlTriggerHeader::GetSerializedSize() const
 {
@@ -1635,7 +1751,7 @@
     size += 8; // Common Info (excluding Trigger Dependent Common Info)
 
     // Add the size of the Trigger Dependent Common Info subfield
-    if (m_triggerType == GCR_MU_BAR_TRIGGER)
+    if (m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER)
     {
         size += 4;
     }
@@ -1653,15 +1769,17 @@
 void
 CtrlTriggerHeader::Serialize(Buffer::Iterator start) const
 {
-    NS_ABORT_MSG_IF(m_triggerType == BFRP_TRIGGER, "BFRP Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == GCR_MU_BAR_TRIGGER,
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
+                    "BFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER,
                     "GCR-MU-BAR Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == NFRP_TRIGGER, "NFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
+                    "NFRP Trigger frame is not supported");
 
     Buffer::Iterator i = start;
 
     uint64_t commonInfo = 0;
-    commonInfo |= (m_triggerType & 0x0f);
+    commonInfo |= (static_cast<uint8_t>(m_triggerType) & 0x0f);
     commonInfo |= (m_ulLength & 0x0fff) << 4;
     commonInfo |= (m_moreTF ? 1 << 16 : 0);
     commonInfo |= (m_csRequired ? 1 << 17 : 0);
@@ -1669,6 +1787,11 @@
     commonInfo |= (m_giAndLtfType & 0x03) << 20;
     commonInfo |= static_cast<uint64_t>(m_apTxPower & 0x3f) << 28;
     commonInfo |= static_cast<uint64_t>(m_ulSpatialReuse) << 37;
+    if (m_variant == TriggerFrameVariant::HE)
+    {
+        uint64_t ulHeSigA2 = 0x01ff; // nine bits equal to 1
+        commonInfo |= ulHeSigA2 << 54;
+    }
 
     i.WriteHtolsbU64(commonInfo);
 
@@ -1687,7 +1810,7 @@
 
     uint64_t commonInfo = i.ReadLsbtohU64();
 
-    m_triggerType = (commonInfo & 0x0f);
+    m_triggerType = static_cast<TriggerFrameType>(commonInfo & 0x0f);
     m_ulLength = (commonInfo >> 4) & 0x0fff;
     m_moreTF = (commonInfo >> 16) & 0x01;
     m_csRequired = (commonInfo >> 17) & 0x01;
@@ -1695,12 +1818,16 @@
     m_giAndLtfType = (commonInfo >> 20) & 0x03;
     m_apTxPower = (commonInfo >> 28) & 0x3f;
     m_ulSpatialReuse = (commonInfo >> 37) & 0xffff;
+    uint8_t bit54and55 = (commonInfo >> 54) & 0x03;
+    m_variant = bit54and55 == 3 ? TriggerFrameVariant::HE : TriggerFrameVariant::EHT;
     m_userInfoFields.clear();
 
-    NS_ABORT_MSG_IF(m_triggerType == BFRP_TRIGGER, "BFRP Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == GCR_MU_BAR_TRIGGER,
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
+                    "BFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER,
                     "GCR-MU-BAR Trigger frame is not supported");
-    NS_ABORT_MSG_IF(m_triggerType == NFRP_TRIGGER, "NFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
+                    "NFRP Trigger frame is not supported");
 
     bool isPadding = false;
 
@@ -1733,7 +1860,7 @@
 TriggerFrameType
 CtrlTriggerHeader::GetType() const
 {
-    return static_cast<TriggerFrameType>(m_triggerType);
+    return m_triggerType;
 }
 
 const char*
@@ -1746,7 +1873,7 @@
 CtrlTriggerHeader::GetTypeString(TriggerFrameType type)
 {
 #define FOO(x)                                                                                     \
-    case x:                                                                                        \
+    case TriggerFrameType::x:                                                                      \
         return #x;                                                                                 \
         break;
 
@@ -1769,49 +1896,49 @@
 bool
 CtrlTriggerHeader::IsBasic() const
 {
-    return (m_triggerType == BASIC_TRIGGER);
+    return (m_triggerType == TriggerFrameType::BASIC_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsBfrp() const
 {
-    return (m_triggerType == BFRP_TRIGGER);
+    return (m_triggerType == TriggerFrameType::BFRP_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsMuBar() const
 {
-    return (m_triggerType == MU_BAR_TRIGGER);
+    return (m_triggerType == TriggerFrameType::MU_BAR_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsMuRts() const
 {
-    return (m_triggerType == MU_RTS_TRIGGER);
+    return (m_triggerType == TriggerFrameType::MU_RTS_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsBsrp() const
 {
-    return (m_triggerType == BSRP_TRIGGER);
+    return (m_triggerType == TriggerFrameType::BSRP_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsGcrMuBar() const
 {
-    return (m_triggerType == GCR_MU_BAR_TRIGGER);
+    return (m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsBqrp() const
 {
-    return (m_triggerType == BQRP_TRIGGER);
+    return (m_triggerType == TriggerFrameType::BQRP_TRIGGER);
 }
 
 bool
 CtrlTriggerHeader::IsNfrp() const
 {
-    return (m_triggerType == NFRP_TRIGGER);
+    return (m_triggerType == TriggerFrameType::NFRP_TRIGGER);
 }
 
 void
@@ -1829,18 +1956,19 @@
 WifiTxVector
 CtrlTriggerHeader::GetHeTbTxVector(uint16_t staId) const
 {
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
+                    "GetHeTbTxVector() cannot be used for MU-RTS");
     auto userInfoIt = FindUserInfoWithAid(staId);
     NS_ASSERT(userInfoIt != end());
 
     WifiTxVector v;
-    v.SetPreambleType(WifiPreamble::WIFI_PREAMBLE_HE_TB);
+    v.SetPreambleType(userInfoIt->GetPreambleType());
     v.SetChannelWidth(GetUlBandwidth());
     v.SetGuardInterval(GetGuardInterval());
     v.SetLength(GetUlLength());
-    v.SetHeMuUserInfo(staId,
-                      {userInfoIt->GetRuAllocation(),
-                       HePhy::GetHeMcs(userInfoIt->GetUlMcs()),
-                       userInfoIt->GetNss()});
+    v.SetHeMuUserInfo(
+        staId,
+        {userInfoIt->GetRuAllocation(), userInfoIt->GetUlMcs(), userInfoIt->GetNss()});
     return v;
 }
 
@@ -1996,7 +2124,7 @@
 CtrlTriggerUserInfoField&
 CtrlTriggerHeader::AddUserInfoField()
 {
-    m_userInfoFields.emplace_back(m_triggerType);
+    m_userInfoFields.emplace_back(m_triggerType, m_variant);
     return m_userInfoFields.back();
 }
 
@@ -2083,6 +2211,11 @@
 bool
 CtrlTriggerHeader::IsValid() const
 {
+    if (m_triggerType == TriggerFrameType::MU_RTS_TRIGGER)
+    {
+        return true;
+    }
+
     // check that allocated RUs do not overlap
     // TODO This is not a problem in case of UL MU-MIMO
     std::vector<HeRu::RuSpec> prevRus;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/ctrl-headers.h ns-3.38/src/wifi/model/ctrl-headers.h
--- ns-3.37/src/wifi/model/ctrl-headers.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/ctrl-headers.h	2023-03-16 20:54:23.852869300 -0700
@@ -21,6 +21,7 @@
 #define CTRL_HEADERS_H
 
 #include "block-ack-type.h"
+#include "wifi-phy-common.h"
 
 #include "ns3/he-ru.h"
 #include "ns3/header.h"
@@ -555,7 +556,7 @@
  * \ingroup wifi
  * The different Trigger frame types.
  */
-enum TriggerFrameType : uint8_t
+enum class TriggerFrameType : uint8_t
 {
     BASIC_TRIGGER = 0,      // Basic
     BFRP_TRIGGER = 1,       // Beamforming Report Poll
@@ -569,6 +570,16 @@
 
 /**
  * \ingroup wifi
+ * The different variants for Common Info field and User Info field of Trigger Frames.
+ */
+enum class TriggerFrameVariant : uint8_t
+{
+    HE = 0,
+    EHT
+};
+
+/**
+ * \ingroup wifi
  * \brief User Info field of Trigger frames.
  *
  * Trigger frames, introduced by 802.11ax amendment (see Section 9.3.1.23 of D3.0),
@@ -582,8 +593,9 @@
      * Constructor
      *
      * \param triggerType the Trigger frame type
+     * \param variant the Trigger Frame variant
      */
-    CtrlTriggerUserInfoField(uint8_t triggerType);
+    CtrlTriggerUserInfoField(TriggerFrameType triggerType, TriggerFrameVariant variant);
     /**
      * Copy assignment operator.
      *
@@ -633,6 +645,10 @@
      */
     TriggerFrameType GetType() const;
     /**
+     * \return the preamble type of the TB PPDU solicited by this User Info field.
+     */
+    WifiPreamble GetPreambleType() const;
+    /**
      * Set the AID12 subfield, which carries the 12 LSBs of the AID of the
      * station for which this User Info field is intended. The whole AID can
      * be passed, since the passed value is properly masked.
@@ -662,17 +678,55 @@
     bool HasRaRuForUnassociatedSta() const;
     /**
      * Set the RU Allocation subfield according to the specified RU.
+     * This method cannot be called on MU-RTS Trigger Frames (call SetMuRtsRuAllocation instead).
      *
      * \param ru the RU this User Info field is allocating
      */
     void SetRuAllocation(HeRu::RuSpec ru);
     /**
      * Get the RU specified by the RU Allocation subfield.
+     * This method cannot be called on MU-RTS Trigger Frames (call GetMuRtsRuAllocation instead).
      *
      * \return the RU this User Info field is allocating
      */
     HeRu::RuSpec GetRuAllocation() const;
     /**
+     * Set the RU Allocation subfield based on the given value for the B7-B1 bits.
+     * This method can only be called on MU-RTS Trigger Frames.
+     *
+     * B7–B1 of the RU Allocation subfield is set to indicate the primary 20 MHz channel
+     * as follows:
+     * - 61 if the primary 20 MHz channel is the only 20 MHz channel or the lowest frequency
+     *   20 MHz channel in the primary 40 MHz channel or primary 80 MHz channel
+     * - 62 if the primary 20 MHz channel is the second lowest frequency 20 MHz channel in the
+     *   primary 40 MHz channel or primary 80 MHz channel
+     * - 63 if the primary 20 MHz channel is the third lowest frequency 20 MHz channel in the
+     *   primary 80 MHz channel
+     * - 64 if the primary 20 MHz channel is the fourth lowest frequency 20 MHz channel in the
+     *   primary 80 MHz channel
+     *
+     * B7–B1 of the RU Allocation subfield is set to indicate the primary 40 MHz channel
+     * as follows:
+     * - 65 if the primary 40 MHz channel is the only 40 MHz channel or the lowest frequency
+     *   40 MHz channel in the primary 80 MHz channel
+     * - 66 if the primary 40 MHz channel is the second lowest frequency 40 MHz channel in the
+     *   primary 80 MHz channel
+     *
+     * B7–B1 of the RU Allocation subfield is set to 67 to indicate the primary 80 MHz channel.
+     *
+     * B7–B1 of the RU Allocation subfield is set to 68 to indicate the primary and secondary
+     * 80 MHz channel.
+     *
+     * \param value the value for B7–B1 of the RU Allocation subfield
+     */
+    void SetMuRtsRuAllocation(uint8_t value);
+    /**
+     * This method can only be called on MU-RTS Trigger Frames.
+     *
+     * \return the value of B7–B1 of the RU Allocation subfield (\see SetMuRtsRuAllocation)
+     */
+    uint8_t GetMuRtsRuAllocation() const;
+    /**
      * Set the UL FEC Coding Type subfield, which indicates whether BCC or LDPC is used
      *
      * \param ldpc whether to use LDPC or not
@@ -697,13 +751,15 @@
      */
     uint8_t GetUlMcs() const;
     /**
-     * Set the UL DCM subfield, which indicates whether or not DCM is used
+     * Set the UL DCM subfield, which indicates whether or not DCM is used.
+     * This method can only be used with HE variant User Info field.
      *
      * \param dcm whether to use DCM or not
      */
     void SetUlDcm(bool dcm);
     /**
      * Get the UL DCM subfield, which indicates whether or not DCM is used
+     * This method can only be used with HE variant User Info field.
      *
      * \return true if DCM is used
      */
@@ -831,11 +887,14 @@
     const CtrlBAckRequestHeader& GetMuBarTriggerDepUserInfo() const;
 
   private:
+    TriggerFrameVariant m_variant; //!< User Info field variant
+
     uint16_t m_aid12;       //!< Association ID of the addressed station
     uint8_t m_ruAllocation; //!< RU Allocation
     bool m_ulFecCodingType; //!< UL FEC Coding Type
     uint8_t m_ulMcs;        //!< MCS to be used by the addressed station
-    bool m_ulDcm;           //!< whether or not to use Dual Carrier Modulation
+    bool m_ulDcm;           //!< whether or not to use Dual Carrier Modulation (HE variant only)
+    bool m_ps160;           //!< identifies the location of the RU (EHT variant only)
 
     union {
         struct
@@ -852,7 +911,7 @@
     } m_bits26To31;        //!< Fields occupying bits 26-31 in the User Info field
 
     uint8_t m_ulTargetRssi;                  //!< Expected receive signal power
-    uint8_t m_triggerType;                   //!< Trigger frame type
+    TriggerFrameType m_triggerType;          //!< Trigger frame type
     uint8_t m_basicTriggerDependentUserInfo; //!< Basic Trigger variant of Trigger Dependent User
                                              //!< Info subfield
     CtrlBAckRequestHeader
@@ -898,6 +957,8 @@
      *     UL MCS and SS Allocation subfields of each User Info field are set based
      *     on the values stored in the corresponding entry of the HeMuUserInfoMap.
      *
+     * This constructor cannot be used to construct MU-RTS Trigger Frames.
+     *
      * \param type the Trigger frame type
      * \param txVector the TX vector used to build this Trigger Frame
      */
@@ -925,6 +986,21 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 
     /**
+     * Set the Common Info field variant.
+     *
+     * For the moment, all User Info fields are of the same variant type, hence we
+     * forbid changing the Common Info field variant type after adding User Info fields.
+     *
+     * \param variant the Common Info field variant
+     */
+    void SetVariant(TriggerFrameVariant variant);
+    /**
+     * Get the Common Info field variant.
+     *
+     * \return the Common Info field variant
+     */
+    TriggerFrameVariant GetVariant() const;
+    /**
      * Set the Trigger frame type.
      *
      * \param type the Trigger frame type
@@ -1244,14 +1320,16 @@
     /**
      * Common Info field
      */
-    uint8_t m_triggerType;     //!< Trigger type
-    uint16_t m_ulLength;       //!< Value for the L-SIG Length field
-    bool m_moreTF;             //!< True if a subsequent Trigger frame follows
-    bool m_csRequired;         //!< Carrier Sense required
-    uint8_t m_ulBandwidth;     //!< UL BW subfield
-    uint8_t m_giAndLtfType;    //!< GI And LTF Type subfield
-    uint8_t m_apTxPower;       //!< Tx Power used by AP to transmit the Trigger Frame
-    uint16_t m_ulSpatialReuse; //!< Value for the Spatial Reuse field in HE-SIG-A
+    TriggerFrameVariant m_variant;  //!< Common Info field variant
+    TriggerFrameType m_triggerType; //!< Trigger type
+    uint16_t m_ulLength;            //!< Value for the L-SIG Length field
+    bool m_moreTF;                  //!< True if a subsequent Trigger frame follows
+    bool m_csRequired;              //!< Carrier Sense required
+    uint8_t m_ulBandwidth;          //!< UL BW subfield
+    uint8_t m_giAndLtfType;         //!< GI And LTF Type subfield
+    uint8_t m_apTxPower;            //!< Tx Power used by AP to transmit the Trigger Frame
+    uint16_t m_ulSpatialReuse;      //!< Value for the Spatial Reuse field in HE-SIG-A
+
     /**
      * List of User Info fields
      */
